Index: /extensions/SmartAlbums/include/functions.inc.php
===================================================================
--- /extensions/SmartAlbums/include/functions.inc.php	(revision 16103)
+++ /extensions/SmartAlbums/include/functions.inc.php	(revision 16104)
@@ -36,5 +36,5 @@
   }
   
-  // represantant, try to not overwrite if still in images list
+  // representant, try to not overwrite if still in images list
   $query = '
 SELECT representative_picture_id
@@ -46,8 +46,5 @@
   if ( !in_array($rep_id, $images) )
   {
-    if (!function_exists('set_random_representant'))
-    {
-      include(PHPWG_ROOT_PATH.'admin/include/functions.php');
-    }
+    include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
     set_random_representant(array($cat_id));
   }
@@ -64,6 +61,4 @@
 {
   global $conf;
-    
-  if (!is_array($conf['SmartAlbums'])) $conf['SmartAlbums'] = unserialize($conf['SmartAlbums']);
   
   if ( defined('SMART_NOT_UPDATE') OR !$conf['SmartAlbums']['update_on_upload'] ) return;
@@ -94,8 +89,6 @@
 
   /* get filters */
-  if ($filters == null)
-  {
-    $filters = array();
-    
+  if ($filters === null)
+  {
     $query = '
 SELECT * 
@@ -106,6 +99,7 @@
     $result = pwg_query($query);
     
-    if (!pwg_db_num_rows($result)) return $filters;
+    if (!pwg_db_num_rows($result)) return array();
     
+    $filters = array();
     while ($row = pwg_db_fetch_assoc($result))
     {
@@ -117,96 +111,202 @@
     }
   }
+  else if (!count($filters))
+  {
+    return array();
+  }
     
   /* build constrains */
   ## generate 'join', 'where' arrays and 'limit' string to create the SQL query
-  ## inspired by PicsEngine by Michael Villar
+  ## inspired by PicsEngine 3 by Michael Villar
   $i_tags = 1;
   foreach ($filters as $filter)
   {
-    // tags
-    if ($filter['type'] == 'tags')
-    {
-      if($filter['cond'] == "all")
-      {
-        $tags_arr = explode(',', $filter['value']);
+    switch ($filter['type'])
+    {
+      // tags
+      case 'tags':
+      {
+        switch ($filter['cond'])
+        {
+          // search images which have all tags
+          case 'all':
+          {
+            $tags_arr = explode(',', $filter['value']);
+            foreach($tags_arr as $value)
+            {
+              $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+              $where[] = 'it'.$i_tags.'.tag_id = '.$value;
+              $i_tags++;
+            }
+            
+            break;
+          }
+          // search images which tags are in the list
+          case 'one':
+          {
+            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+            $where[] = 'it'.$i_tags.'.tag_id IN ('.$filter['value'].')';
+            $i_tags++;
+            
+            break;
+          }
+          // exclude images which tags are in the list
+          case 'none':
+          {
+            $sub_query = '
+      SELECT it'.$i_tags.'.image_id
+        FROM '.IMAGE_TAG_TABLE.' AS it'.$i_tags.'
+        WHERE 
+          it'.$i_tags.'.image_id = i.id AND
+          it'.$i_tags.'.tag_id IN ('.$filter['value'].')
+        GROUP BY it'.$i_tags.'.image_id
+      ';
+            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+            $where[] = 'NOT EXISTS ('.$sub_query.')';
+            $i_tags++;
+            
+            break;
+          }
+          // exclude images which tags are not in the list and search images which have all tags
+          case 'only':
+          {
+            $sub_query = '
+      SELECT it'.$i_tags.'.image_id
+        FROM '.IMAGE_TAG_TABLE.' AS it'.$i_tags.'
+        WHERE 
+          it'.$i_tags.'.image_id = i.id AND
+          it'.$i_tags.'.tag_id NOT IN ('.$filter['value'].')
+        GROUP BY it'.$i_tags.'.image_id
+      ';
+            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+            $where[] = 'NOT EXISTS ('.$sub_query.')';
+            $i_tags++;
+            
+            $tags_arr = explode(',', $filter['value']);
+            foreach($tags_arr as $value)
+            {
+              $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+              $where[] = 'it'.$i_tags.'.tag_id = '.$value;
+              $i_tags++;
+            }
+            
+            break;
+          }
+        }
         
-        foreach($tags_arr as $value)
-        {
-          $join[] = IMAGE_TAG_TABLE.' AS it_'.$i_tags.' ON i.id = it_'.$i_tags.'.image_id';
-          $where[] = 'it_'.$i_tags.'.tag_id = '.$value;
-          $i_tags++;
-        }
-      }
-      else if ($filter['cond'] == 'one') 
-      {
-        $join[] = IMAGE_TAG_TABLE.' AS it_'.$i_tags.' ON i.id = it_'.$i_tags.'.image_id';
-        $where[] = 'it_'.$i_tags.'.tag_id IN ('.$filter['value'].')';
-        $i_tags++;
-      }
-      else if ($filter['cond'] == 'none') 
-      {
-        $sub_query = '
-      SELECT it_'.$i_tags.'.image_id
-        FROM '.IMAGE_TAG_TABLE.' AS it_'.$i_tags.'
-        WHERE 
-          it_'.$i_tags.'.image_id = i.id AND
-          it_'.$i_tags.'.tag_id IN ('.$filter['value'].')
-        GROUP BY it_'.$i_tags.'.image_id
-    ';
-        $where[] = 'NOT EXISTS ('.$sub_query.')';
-        $i_tags++;
-      }
-      else if ($filter['cond'] == 'only') 
-      {
-        $sub_query = '
-      SELECT it_'.$i_tags.'.image_id
-        FROM '.IMAGE_TAG_TABLE.' AS it_'.$i_tags.'
-        WHERE 
-          it_'.$i_tags.'.image_id = i.id AND
-          it_'.$i_tags.'.tag_id NOT IN ('.$filter['value'].')
-        GROUP BY it_'.$i_tags.'.image_id
-    ';
-        $where[] = 'NOT EXISTS ('.$sub_query.')';
+        break;
+      }
+    
+      // date
+      case 'date':
+      {
+        switch ($filter['cond'])
+        {
+          case 'the_post':
+            $where[] = 'date_available BETWEEN "'.$filter['value'].' 00:00:00" AND "'.$filter['value'].' 23:59:59"';
+            break;
+          case 'before_post':
+            $where[] = 'date_available < "'.$filter['value'].' 00:00:00"';
+            break;
+          case 'after_post':
+            $where[] = 'date_available > "'.$filter['value'].' 23:59:59"';
+            break;
+          case 'the_taken':
+            $where[] = 'date_creation BETWEEN "'.$filter['value'].' 00:00:00" AND "'.$filter['value'].' 23:59:59"';
+            break;
+          case 'before_taken':
+            $where[] = 'date_creation < "'.$filter['value'].' 00:00:00"';
+            break;
+          case 'after_taken':
+            $where[] = 'date_creation > "'.$filter['value'].' 23:59:59"';
+            break;
+        }
+        
+        break;
+      }
       
-        $i_tags++;
-        $tags_arr = explode(',', $filter['value']);
+      // name
+      case 'name':
+      {
+        switch ($filter['cond'])
+        {
+          case 'contain':
+            $where[] = 'name LIKE "%'.$filter['value'].'%"';
+            break;
+          case 'begin':
+            $where[] = 'name LIKE "'.$filter['value'].'%"';
+            break;
+          case 'end':
+            $where[] = 'name LIKE "%'.$filter['value'].'"';
+            break;
+          case 'not_contain':
+            $where[] = 'name NOT LIKE "%'.$filter['value'].'%"';
+            break;
+          case 'not_begin':
+            $where[] = 'name NOT LIKE "'.$filter['value'].'%"';
+            break;
+          case 'not_end':
+            $where[] = 'name NOT LIKE "%'.$filter['value'].'"';
+            break;
+        }
         
-        foreach($tags_arr as $value)
-        {
-          $join[] = IMAGE_TAG_TABLE.' AS it_'.$i_tags.' ON i.id = it_'.$i_tags.'.image_id';
-          $where[] = 'it_'.$i_tags.'.tag_id = '.$value;
-          $i_tags++;
-        }
-      }        
-    }
-    // date
-    else if ($filter['type'] == 'date')
-    {
-      switch ($filter['cond'])
-      {
-        case 'the':
-          $where[] = 'date_available BETWEEN "'.$filter['value'].' 00:00:00" AND "'.$filter['value'].' 23:59:59"';
-          break;
-        case 'before':
-          $where[] = 'date_available < "'.$filter['value'].' 00:00:00"';
-          break;
-        case 'after':
-          $where[] = 'date_available > "'.$filter['value'].' 23:59:59"';
-          break;
-        case 'the_crea':
-          $where[] = 'date_creation BETWEEN "'.$filter['value'].' 00:00:00" AND "'.$filter['value'].' 23:59:59"';
-          break;
-        case 'before_crea':
-          $where[] = 'date_creation < "'.$filter['value'].' 00:00:00"';
-          break;
-        case 'after_crea':
-          $where[] = 'date_creation > "'.$filter['value'].' 23:59:59"';
-          break;
-      }
-    }
-    // limit
-    else if ($filter['type'] == 'limit')
-    {
-      $limit = '0, '.$filter['value'];
+        break;
+      }
+      
+      // author
+      case 'author':
+      {
+        switch ($filter['cond'])
+        {
+          case 'is':
+            if ($filter['value'] != 'NULL') $filter['value'] = '"'.$filter['value'].'"';
+            $where[] = 'author = '.$filter['value'].'';
+            break;
+          case 'not_is':
+            if ($filter['value'] != 'NULL') $filter['value'] = '"'.$filter['value'].'"';
+            $where[] = 'author != '.$filter['value'].'';
+            break;
+          case 'in':
+            $filter['value'] = '"'.str_replace(',', '","', $filter['value']).'"';
+            $where[] = 'author IN('.$filter['value'].')';
+            break;
+          case 'not_in':
+            $filter['value'] = '"'.str_replace(',', '","', $filter['value']).'"';
+            $where[] = 'author NOT IN('.$filter['value'].')';
+            break;
+        }
+        
+        break;
+      }
+      
+      // hit
+      case 'hit':
+      {
+        switch ($filter['cond'])
+        {
+          case 'less':
+            $where[] = 'hit < '.$filter['value'].'';
+            break;
+          case 'more':
+            $where[] = 'hit >= '.$filter['value'].'';
+            break;
+        }
+        
+        break;
+      }
+      
+      // level
+      case 'level':
+      {
+        $where[] = 'level = '.$filter['value'].'';
+        break;
+      }
+      
+      // limit
+      case 'limit':
+      {
+        $limit = '0, '.$filter['value'];
+        break;
+      }
     }
   }
@@ -219,30 +319,21 @@
     if (isset($join))
     {
-      foreach ($join as $query)
-      {
-        $MainQuery .= '
-    LEFT JOIN '.$query;
-      }
+      $MainQuery.= '
+    LEFT JOIN '.implode("\n    LEFT JOIN ", $join);
     }
     if (isset($where))
     {
-      $MainQuery .= '
-  WHERE';
-      $i = 0;
-      foreach ($where as $query)
-      {
-        if ($i != 0) $MainQuery .= ' AND';
-        $MainQuery .= '
-    '.$query;
-        $i++;
-      }
-    }
-
-    $MainQuery .= '
+      $MainQuery.= '
+  WHERE
+    '.implode("\n    AND ", $where);
+    }
+
+  $MainQuery.= '
   GROUP BY i.id
- '.$conf['order_by'].'
+  '.$conf['order_by'].'
   '.(isset($limit) ? "LIMIT ".$limit : null).'
 ;';
 
+  // file_put_contents(SMART_PATH.'query.sql', $MainQuery);
   return array_from_query($MainQuery, 'id');
 }
@@ -256,6 +347,9 @@
 function smart_check_filter($filter)
 {
-  global $limit_is_set, $page;
+  global $page, $limit_is_set, $level_is_set;
   $error = false;
+  
+  if (!isset($limit_is_set)) $limit_is_set = false;
+  if (!isset($level_is_set)) $level_is_set = false;
   
   # tags
@@ -281,4 +375,48 @@
     }
   }
+  # name
+  else if ($filter['type'] == 'name')
+  {
+    if (empty($filter['value']))
+    {
+      $error = true;
+      array_push($page['errors'], l10n('Name is empty'));
+    }
+  }
+  # author
+  else if ($filter['type'] == 'author')
+  {
+    if (empty($filter['value']))
+    {
+      $error = true;
+      array_push($page['errors'], l10n('Author is empty'));
+    }
+    else
+    {
+      $filter['value'] = preg_replace('#([ ]?),([ ]?)#', ',', $filter['value']);
+    }
+  }
+  # hit
+  else if ($filter['type'] == 'hit')
+  {
+    if (!preg_match('#([0-9]{1,})#', $filter['value']))
+    {
+      $error = true;
+      array_push($page['errors'], l10n('Hits must be an integer'));
+    }
+  }
+  # level
+  else if ($filter['type'] == 'level')
+  {
+    if ($level_is_set == true) // only one level is allowed, first is saved
+    {
+      $error = true;
+      array_push($page['errors'], l10n('You can\'t use more than one level filter'));
+    }
+    else
+    {
+      $level_is_set = true;
+    }
+  }
   # limit
   else if ($filter['type'] == 'limit')
@@ -292,5 +430,5 @@
     {
       $error = true;
-      array_push($page['errors'], l10n('You can\'t use more than one limit'));
+      array_push($page['errors'], l10n('You can\'t use more than one limit filter'));
     }
     else
@@ -374,3 +512,4 @@
   }
 }
+
 ?>
Index: /extensions/SmartAlbums/include/index.php
===================================================================
--- /extensions/SmartAlbums/include/index.php	(revision 16103)
+++ /extensions/SmartAlbums/include/index.php	(revision 16104)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2011 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
Index: /extensions/SmartAlbums/include/page_items.php
===================================================================
--- /extensions/SmartAlbums/include/page_items.php	(revision 16104)
+++ /extensions/SmartAlbums/include/page_items.php	(revision 16104)
@@ -0,0 +1,97 @@
+<?php
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+/**
+ * Remove picture that musn't be displayed from $page['items']
+ *
+ * here we get all pictures that current user could see 
+ * if SmartAlbums doesn't exist, and make intersect with pictures
+ * actually displayed
+ */
+function smart_init_page_items()
+{
+  global $user, $page, $conf;
+
+  if (
+    ('categories' == $page['section']) and
+    (!isset($page['chronology_field'])) and
+    (
+      (isset($page['category'])) or
+      (isset($page['flat']))
+    )
+  ) {
+  
+    $query = '
+SELECT DISTINCT(cat.id) AS id
+  FROM '.CATEGORIES_TABLE.' AS cat
+    INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS img
+    ON img.category_id = cat.id
+  WHERE img.smart = "true"
+;';
+    $smart_albums = array_from_query($query, 'id');
+      
+    if (count($smart_albums) > 0 and !is_admin())
+    {
+      // add SmartAlbums to forbidden categories
+      $user['forbidden_categories_old'] = $user['forbidden_categories'];
+      $user['forbidden_categories'] = explode(',', $user['forbidden_categories']);
+      $user['forbidden_categories'] = array_unique(array_merge($user['forbidden_categories'], $smart_albums));
+      $user['forbidden_categories'] = implode(',', $user['forbidden_categories']);
+    
+      if ( isset($page['category']) )
+      {
+        $query = '
+SELECT id
+  FROM '.CATEGORIES_TABLE.'
+  WHERE
+    '.get_sql_condition_FandF(
+      array(
+        'forbidden_categories' => 'id',
+        'visible_categories' => 'id',
+        )
+      );
+        $subcat_ids = array_from_query($query, 'id');
+        $subcat_ids[] = 0;
+        $where_sql = 'category_id IN ('.implode(',',$subcat_ids).')';
+        // remove categories from forbidden because just checked above
+        $forbidden = get_sql_condition_FandF(
+          array( 
+            'visible_images' => 'id'
+            ),
+          'AND'
+          );
+      }
+      else
+      {
+        $where_sql = '1=1';
+        $forbidden = get_sql_condition_FandF(
+          array(
+            'forbidden_categories' => 'category_id',
+            'visible_categories' => 'category_id',
+            'visible_images' => 'id'
+            ),
+          'AND'
+          );
+      }
+
+      // Main query
+      $query = '
+SELECT DISTINCT(image_id)
+  FROM '.IMAGE_CATEGORY_TABLE.'
+    INNER JOIN '.IMAGES_TABLE.' ON id = image_id
+  WHERE
+    '.$where_sql.'
+'.$forbidden.'
+  '.$conf['order_by'].'
+;';
+
+      $page['items_wo_sa'] = array_from_query($query, 'image_id');
+      $page['items'] = array_intersect($page['items'], $page['items_wo_sa']);
+      
+      // restore forbidden categories
+      $user['forbidden_categories'] = $user['forbidden_categories_old'];
+    }
+  }
+}
+
+?>
Index: /extensions/SmartAlbums/index.php
===================================================================
--- /extensions/SmartAlbums/index.php	(revision 16103)
+++ /extensions/SmartAlbums/index.php	(revision 16104)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2011 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
Index: /extensions/SmartAlbums/language/ca_ES/index.php
===================================================================
--- /extensions/SmartAlbums/language/ca_ES/index.php	(revision 16104)
+++ /extensions/SmartAlbums/language/ca_ES/index.php	(revision 16104)
@@ -0,0 +1,7 @@
+<?php
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: /extensions/SmartAlbums/language/cs_CZ/index.php
===================================================================
--- /extensions/SmartAlbums/language/cs_CZ/index.php	(revision 16103)
+++ /extensions/SmartAlbums/language/cs_CZ/index.php	(revision 16104)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based picture gallery                                  |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2010 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
Index: /extensions/SmartAlbums/language/de_DE/index.php
===================================================================
--- /extensions/SmartAlbums/language/de_DE/index.php	(revision 16103)
+++ /extensions/SmartAlbums/language/de_DE/index.php	(revision 16104)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based picture gallery                                  |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2010 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
Index: /extensions/SmartAlbums/language/en_UK/index.php
===================================================================
--- /extensions/SmartAlbums/language/en_UK/index.php	(revision 16103)
+++ /extensions/SmartAlbums/language/en_UK/index.php	(revision 16104)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based picture gallery                                  |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2010 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
Index: /extensions/SmartAlbums/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/SmartAlbums/language/en_UK/plugin.lang.php	(revision 16103)
+++ /extensions/SmartAlbums/language/en_UK/plugin.lang.php	(revision 16104)
@@ -1,10 +1,7 @@
 <?php
 
-$lang['%d photos associated to album %s'] = '%d photos associated to album %s';
 $lang['No filter selected'] = 'No filter selected';
-$lang['No tag selected'] = 'No tag selected';
-$lang['Date string is malformed'] = 'Date string is malformed';
-$lang['Limit must be an integer'] = 'Limit must be an integer';
-$lang['You can\'t use more than one limit'] = 'You can\'t use more than one limit';
+$lang['%d photo'] = '%d photo';
+$lang['%d photos'] = '%d photos';
 $lang['All these tags'] = 'All these tags';
 $lang['One of these tags'] = 'One of these tags';
@@ -14,26 +11,50 @@
 $lang['Added before'] = 'Added before';
 $lang['Added after'] = 'Added after';
-$lang['Created on'] = 'Created on';
 $lang['Created before'] = 'Created before';
 $lang['Created after'] = 'Created after';
-$lang['%d photo'] = '%d photo';
-$lang['%d photos'] = '%d photos';
-$lang['tags filter'] = 'tags filter';
-$lang['date filter'] = 'date filter';
-$lang['limit filter'] = 'limit filter';
-$lang['Add filters here'] = 'Add filters here';
-$lang['This album is a SmartAlbum'] = 'This album is a SmartAlbum';
-$lang['Count'] = 'Count';
-$lang['Regenerate photos list of this SmartAlbum'] = 'Regenerate photos list of this SmartAlbum';
-$lang['Regenerate photos list of all SmartAlbums'] = 'Regenerate photos list of all SmartAlbums';
-$lang['Update albums on file upload'] = 'Update albums on file upload';
-$lang['(can cause slowdowns on admin pages)'] = '(can cause slowdowns on admin pages)';
-$lang['All SmartAlbums'] = 'All SmartAlbums';
-$lang['Add a SmartAlbum'] = 'Add a SmartAlbum';
+$lang['Contains'] = 'Contains';
+$lang['Begins with'] = 'Begins with';
+$lang['Ends with'] = 'Ends with';
+$lang['Doesn\'t contain'] = 'Doesn\'t contain';
+$lang['Doesn\'t begin with'] = 'Doesn\'t begin with';
+$lang['Doesn\'t end with'] = 'Doesn\'t end with';
+$lang['Is'] = 'Is';
+$lang['Is in'] = 'Is in';
+$lang['Is not'] = 'Is not';
+$lang['Is not in'] = 'Is not in';
+$lang['Bellow'] = 'Bellow';
+$lang['Above'] = 'Above';
 $lang['SmartAlbum deleted'] = 'SmartAlbum deleted';
 $lang['SmartAlbum added'] = 'SmartAlbum added';
+$lang['%d photos associated to album %s'] = '%d photos associated to album %s';
 $lang['Only SmartAlbums are displayed on this page'] = 'Only SmartAlbums are displayed on this page';
-$lang['To order albums please go the main albums management page'] = 'To order albums please go the main albums <a href="admin.php?page=cat_list">management page</a>';
+$lang['To order albums please go the main albums <a href="%s">management page</a>'] = 'To order albums please go the main albums <a href="%s">management page</a>';
 $lang['Don\'t show this message again'] = 'Don\'t show this message again';
+$lang['All SmartAlbums'] = 'All SmartAlbums';
+$lang['No tag selected'] = 'No tag selected';
+$lang['Date string is malformed'] = 'Date string is malformed';
+$lang['Name is empty'] = 'Name is empty';
+$lang['Author is empty'] = 'Author is empty';
+$lang['Hits must be an integer'] = 'Hits must be an integer';
+$lang['Limit must be an integer'] = 'Limit must be an integer';
+$lang['You can\'t use more than one limit filter'] = 'You can\'t use more than one limit filter';
+$lang['You can\'t use more than one level filter'] = 'You can\'t use more than one level filter';
+$lang['tags_filter'] = 'Tags';
+$lang['date_filter'] = 'Date';
+$lang['name_filter'] = 'Photo name';
+$lang['author_filter'] = 'Author';
+$lang['hit_filter'] = 'Hits';
+$lang['level_filter'] = 'Level';
+$lang['limit_filter'] = 'Max. number of photos';
+$lang['For "Is (not) in", separate each author by a comma'] = 'For "Is (not) in", separate each author by a comma';
+$lang['limit_filter'] = 'Max. number of photos';
+$lang['This album is a SmartAlbum'] = 'This album is a SmartAlbum';
+$lang['Add filters here'] = 'Add filters here';
+$lang['Count'] = 'Count';
+$lang['create a new SmartAlbum'] = 'create a new SmartAlbum';
+$lang['Regenerate photos list of all SmartAlbums'] = 'Regenerate photos list of all SmartAlbums';
+$lang['Regenerate photos list of this SmartAlbum'] = 'Regenerate photos list of this SmartAlbum';
+$lang['Update albums on file upload'] = 'Update albums on file upload';
+$lang['(can cause slowdowns)'] = '(can cause slowdowns)';
 
 ?>
